#include <stddef.h>
#include <string.h>

#include "modsetup.h"
#include "xscommon.h"
#include "patchack.h"

#include "hackopts.h"

/* demo */
#include "hacks1dm.h"
/* floppy disk */
#include "hacks2fd.h"
/* compact disk */
#include "hacks3cd.h"

static fix_info listopts[LIST_LEN(cdlsopts)];
static fix_info listhack[LIST_LEN(cdlshack)];
static fix_file fileopts[1];

static fix_info *datalist[3][2] = {
  {dmlsopts, dmlshack},
  {fdlsopts, fdlshack},
  {cdlsopts, cdlshack}
};

/* def min max */
/* default: 0x0A (10) +1! */
static char smMSndVol[] = "\x09\x01\x0A""1\0""2\0""3\0""4\0""5\0""6\0""7\0""8\0""9\0""10\0";
/* default: 0x02 (Hard) */
static char smDiffLev[] = "\x02\x00\x02""Easy\0Medium\0Hard\0";
/* default: 0x01 (Dark) +1! */
static char smHazeLev[] = "\x00\x01\x03""Dark\0Medium\0Light\0";
/* default: 0x01 (Medium) */
static char smFLMSLev[] = "\x01\x00\x02""High\0Medium\0Low\0";
/* default: 0x00 (High) */
static char smWallDet[] = "\x00\x00\x01""High\0Low\0";

static char *smOptions[] = {
  smMSndVol, /* Music Volume */
  smMSndVol, /* Sound Volume */
  smDiffLev,
  smHazeLev,
  smFLMSLev, /* Floor Level */
  smWallDet,
  smFLMSLev  /* Mouse Sens. */
};

static char smainopts[(21 + 1/*+11*/) * 7];
menuitem mainopts[] = {
  {"Options Hacks", NULL, 9},
  {"Music Volume", "Music volume level.", ITEM_HILITE},
  {"Sound Volume", "Sound volume level.", ITEM_HILITE},
  {"Difficulty", "Difficulty level. Will be applied for new game only.", ITEM_HILITE},
  {"Haze Level", "Haze lightning level.", ITEM_HILITE},
  {"Floor Level", "Floor detail level.", ITEM_HILITE},
  {"Wall Detail", "Wall detail level.", ITEM_HILITE},
  {"Mouse Sens.", "Mouse sensivity level.", ITEM_HILITE},
  {"", NULL, ITEM_GRAYED},
  {"Reset options", "Reset all options to their default values.", 0}
};

menuitem resetopt[] = {
  {"Confirm reset?", NULL, 2 | MENU_DLGBOX},
  {"Yes", NULL, 0},
  {"No", NULL, 0}
};

static menuitem mainsens[] = {
  {"Select sensitivity increase number", NULL, 3},
  {"<disabled>", NULL, 0},
  {"by 2 times", NULL, 0},
  {"by 4 times", NULL, 0}
};

menuitem mainhack[] = {
  {"Hacks setup", NULL, 11},
  {
    "Strafe left and right instead turning",
    "[Turn_Left] and [Turn_Right] will work as strafe left and strafe right.",
    ITEM_CHKBOX
  },
  {
    "Use mouse for turning left and right",
    "Mouse usage key will be always active without movement (Y-axis will be ignored).",
    ITEM_CHKBOX
  },
  {
    "Increase X-axis mouse sensitivity: <disabled>",
    "Mouse X-axis sensitivity will be increased by the selected number of times.",
     ITEM_CHKBOX
  },
  {"", NULL, ITEM_GRAYED},
  {
    "All weapons and ammo on a new game",
    "[cheat] Upon starting new game all weapons with full ammo will be available.",
    ITEM_CHKBOX
  },
  {
    "Infinite health",
    "[cheat] Infinite health cheat-code will be initially active.",
    ITEM_CHKBOX
  },
  {
    "Infinite ammo",
    "[cheat] Infinite ammo cheat-code will be initially active.",
    ITEM_CHKBOX
  },
  {
    "Full map",
    "[cheat] Full map cheat-code will be initially active.",
    ITEM_CHKBOX
  },
  {
    "Show coordinates and view angle",
    "[cheat] Coordinates and view angle cheat-code will be initially active.",
    ITEM_CHKBOX
  },
  {
    "Enemies will follow without shooting",
    "[cheat] Peacefully enemies following cheat-code will be initially active.",
    ITEM_CHKBOX
  },
  {
    "No clipping mode (walk through walls)",
    "[cheat] Walking through walls cheat-code will be initially active.",
    ITEM_CHKBOX
  }
};

static menuitem mainfile[] = {
  {"RADIAKI.EXE game version", NULL, 4 | MENU_NFOBOX},
  {"No supported file found", NULL, ITEM_RADBOX | ITEM_GRAYED},
  {"Demo version detected", NULL, ITEM_RADBOX | ITEM_GRAYED},
  {"Floppy version detected", NULL, ITEM_RADBOX | ITEM_GRAYED},
  {"CD version detected", NULL, ITEM_RADBOX | ITEM_GRAYED}
};

/* version autodetect code */
static char filename[] = "RADIAKI.EXE";
static fix_file listwhat[] = {
  /* 0xAAABBBBB: AAA - offs, BBBBB - file size */
  {filename, 0x00380BC3UL}, /* DEMO */
  {filename, 0xF8C8098FUL}, /* FDSK */
  {filename, 0x00080BC3UL}  /* CDSK */
};

int DetectVersion(void) {
fix_item fcon[4];
fix_info lcon;
short i, j;
  memset(&fcon, 0, sizeof(fcon));
  memset(&lcon, 0, sizeof(lcon));
  lcon.size = LIST_LEN(fcon);
  lcon.list = fcon;
  j = 0;
  for (i = 0; i < LIST_LEN(listwhat); i++) {
    j = (listwhat[i].size >> 16);
    j &= 0xFFF0;
    fcon[0].offs = 0x0005440AL + j;
    listwhat[i].size &= 0x000FFFFFUL;
    for (j = 1; j < LIST_LEN(fcon); j++) {
      fcon[j].offs = fcon[0].offs + j;
    }
    /* read data bytes */
    ReadPatches(&listwhat[i], &lcon, 1);
    /* Watcom "con\0" signature */
    if (
      (fcon[0].data == 'c') && (fcon[1].data == 'o') &&
      (fcon[2].data == 'n') && (fcon[3].data == 0x00)
    ) {
      j = i + 1;
      break;
    }
    j = 0;
  }
  if (j) {
    i = j - 1;
    memcpy(listopts, datalist[i][0], sizeof(listopts));
    memcpy(listhack, datalist[i][1], sizeof(listhack));
    memcpy(fileopts, &listwhat[i], sizeof(fileopts));
  } else {
    memset(listopts, 0, sizeof(listopts));
    memset(listhack, 0, sizeof(listhack));
    memset(fileopts, 0, sizeof(fileopts));
  }
  return(j);
}

void SetItemData(menuitem *item, char *s, BYTE v, int p) {
  StrOverlap(&item->item[p], s);
  SetMenuData(*item, v);
}

void PopupMenu(int item) {
menuitem list[11];
char *s;
int i;
  memset(list, 0, sizeof(list));
  list[0].item = "Select desired value";
  i = (item < 0) ? (-item) : item;
  s = &smOptions[i - 1][3];
  for (i = 1; ((i < 11) && (*s)); i++) {
    /* default value - can't select */
    list[i].item = s;
    s += strlen(s) + 1;
    list[0].flag++;
  }
  if (item < 0) {
    i = GetMenuData(mainopts[-item]) + 1;
  } else {
    i = GetMenuData(mainopts[item]);
    SET_LITE(list[1 + i], 1);
    i = DrawMenu(list, NULL);
  }
  item = (item < 0) ? (-item) : item;
  if (i) {
    SetItemData(&mainopts[item], list[i].item, i - 1, 15);
  }
}

void ResetOptions(void) {
int i;
  for (i = 1; i <= LIST_LEN(listopts); i++) {
    SetMenuData(mainopts[i], smOptions[i - 1][0]);
    PopupMenu(-i);
  }
}

void LoadOptions(void) {
char k;
int i;
  /* read patches (since actual patch values required) */
  ReadPatches(fileopts, listopts, LIST_LEN(listopts));
  /* test values */
  for (i = 0; i < LIST_LEN(listopts); i++) {
    k = listopts[i].list->data;
    /* check value in range */
    if ((k < smOptions[i][1]) || (k > smOptions[i][2])) {
      k = smOptions[i][0];
    }
    /* make it zero-based */
    k -= smOptions[i][1];
    /* update menu */
    SetMenuData(mainopts[1 + i], k);
    PopupMenu(-(1 + i));
  }
}

void SaveOptions(void) {
int i;
  for (i = 0; i < LIST_LEN(listopts); i++) {
    /* always modified */
    listopts[i].stat = PH_MOD;
    /* modified byte to write */
    listopts[i].list->data = GetMenuData(mainopts[1 + i]) + smOptions[i][1];
  }
  /* fix music volume byte */
  listopts[0].list[1].data = (127 * listopts[0].list[0].data) / 10;
  /* save changes */
  SavePatches(fileopts, listopts, LIST_LEN(listopts));
}

int MenuOpts(int item, BYTE *key) {
int r;
  r = 1;
  if (!key) {
    switch (item) {
      case 9:
        /* reset everything to default */
        if (DrawMenu(resetopt, NULL) == 1) {
          ResetOptions();
          /* redraw menu */
          r = -1;
        }
        break;
      default:
        PopupMenu(item);
        break;
    }
  }
  return(r);
}

void LoadHacks(void) {
int i, k;
  /* load patches */
  LoadPatches(fileopts, listhack, LIST_LEN(listhack));
  for (i = 0; i < LIST_LEN(listhack); i++) {
    SET_LITE(mainhack[1 + i + ((i > 2) ? 1 : 0)], listhack[i].stat != PH_ORG);
    /* read mouse sens patch data */
    if (i == 2) {
      ReadPatches(fileopts, &listhack[i], 1);
      k = listhack[i].list[0].data;
      if ((k >= 4) && (k <= 6)) {
        k = 6 - k;
      } else {
        k = 0;
      }
      SetItemData(&mainhack[1 + i], mainsens[1 + k].item, k, 35);
    }
  }
}

void SaveHacks(void) {
int i;
  for (i = 0; i < LIST_LEN(listhack); i++) {
    listhack[i].stat = ITS_LITE(mainhack[1 + i + ((i > 2) ? 1 : 0)]) ? PH_MOD : PH_ORG;
    /* save mouse sens patch */
    if (i == 2) {
      listhack[i].list[0].data = 6 - GetMenuData(mainhack[1 + i + ((i > 2) ? 1 : 0)]);
      listhack[i].list[1].data = listhack[i].list[0].data;
    }
  }
  /* save patches */
  SavePatches(fileopts, listhack, LIST_LEN(listhack));
}

int MenuHack(int item, BYTE *key) {
int i;
  if ((!key) && (item == 3)) {
    DefMenuItem(mainsens, GetMenuData(mainhack[item]));
    i = DrawMenu(mainsens, NULL);
    if (i) {
      SetItemData(&mainhack[item], mainsens[i].item, i - 1, 35);
    }
    i = GetMenuData(mainhack[item]);
    /* checked or not */
    SET_LITE(mainhack[item], i);
    /* force redraw */
    item = -1;
  }
  return(item);
}

int LoadHackOptions(void) {
int r;
  r = DetectVersion();
  mainfile[1 + r].flag ^= ITEM_HILITE | ITEM_GRAYED;
  DrawMenu(mainfile, NULL);
  if (r) {
    LoadHacks();
    FillMenu(mainopts, smainopts, 21/*+11*/);
    ResetOptions();
    LoadOptions();
  }
  return(r);
}

void SaveHackOptions(int flag) {
  if (flag & 1) { SaveHacks(); }
  if (flag & 2) { SaveOptions(); }
}

void DoOptionsMenu(void) {
  DrawMenu(mainopts, MenuOpts);
}

void DoHacksMenu(void) {
  DrawMenu(mainhack, MenuHack);
}
