#ifndef __HACKS2FD_H
#define __HACKS2FD_H

#include "PATCHACK.H"

/* floppy disk */

/* Options hacks */

static fix_item fdmusvol[] = {
  {0x0A034720UL, 0x0A},
  /* actual music volume byte */
  {0x7F079244UL, 0x7F}
};

static fix_item fdsndvol[] = {
  {0x0A03472AUL, 0x0A}
};

static fix_item fddfflev[] = {
  {0x0203479FUL, 0x02}
};

static fix_item fdhazlev[] = {
  {0x01041A94UL, 0x01}
};

static fix_item fdflrlev[] = {
  {0x010418D2UL, 0x01}
};

static fix_item fdwlldet[] = {
  {0x000418C8UL, 0x00}
};

static fix_item fdmsesns[] = {
  {0x010347BBUL, 0x01}
};

static fix_info fdlsopts[] = {
  {PH_ORG, 0, LIST_LEN(fdmusvol), fdmusvol},
  {PH_ORG, 0, LIST_LEN(fdsndvol), fdsndvol},
  {PH_ORG, 0, LIST_LEN(fddfflev), fddfflev},
  {PH_ORG, 0, LIST_LEN(fdhazlev), fdhazlev},
  {PH_ORG, 0, LIST_LEN(fdflrlev), fdflrlev},
  {PH_ORG, 0, LIST_LEN(fdwlldet), fdwlldet},
  {PH_ORG, 0, LIST_LEN(fdmsesns), fdmsesns}
};

/* Hacks setup */

static fix_item fdhkstrf[] = {
  /*
    explanation for the strafe code hack
    * pair of two consecutive null funcs at offsets 000501FF, 00050214 and 0005151B, 00051530 was
      used for strafe code placing in the game executable file, since it's new additional feature
      and nothing should be changed, replaced or removed
    * null func is a func that does nothing, but useless pushes and pops registers to / from stack
      so if func immediately returns (C3) all these wasted bytes can be used for something meaningful
      and if you wonder why this code exists in the first place - it's because compilers at that time
      didn't optimize and remove unused or obviously empty code (it's nice, since this come in handy)
    * let's see main idea behind this hack on Strafe Left implementation:
      - Turn Left to 90* degree
      - Move Forward
      - Turn Right to 90* degree to restore original view angle
      the same with the Strafe Right except calls for the Turn Left and Turn Right will be exchanged
    * note that 2880 (0B40h) equal to the 90* degree in the game units
  */
  /* Turn Left => Strafe Left */
  {0x120425DEUL, 0x0E}, /* replace rotate coeff with move coeff */
  {0x120425F2UL, 0x0E},
  {0xA7042629UL, 0xD3}, /* replace TurnLeft call to [SL1] */
  {0xD304262AUL, 0xDB},
  {0xFF04262BUL, 0x00},
  {0xFF04262CUL, 0x00},
  /* Turn Right => Strafe Right */
  {0x1204264EUL, 0x0E}, /* replace rotate coeff with move coeff */
  {0x12042662UL, 0x0E},
  {0xAE042692UL, 0x86},
  {0xD3042693UL, 0xEE}, /* replace TurnLeft call to [SR1] */
  {0xFF042694UL, 0x00},
  {0xFF042695UL, 0x00},
  /* Strafe Left func instead of two null funcs */
  {0x530501FFUL, 0xC3}, /* each null func must return immediately since its body changed */
  {0x51050200UL, 0x52}, /* [SL1] push edx - save argument (distance to move) */
  {0x52050201UL, 0x50}, /* push eax - save argument (global data offset to structure) */
  {0x56050202UL, 0xBA}, /* mov  edx, 0B40h - angle - 90 degree in the game units */
  {0x57050203UL, 0x40},
  {0x55050204UL, 0x0B},
  {0x89050205UL, 0x00},
  {0xE5050206UL, 0x00},
  {0x81050207UL, 0x52}, /* push edx - save angle */
  {0xEC050208UL, 0xE8}, /* call TurnLeft(eax:struct, edx:angle, ebx:0) - turn 90 degree to the left */
  {0x00050209UL, 0xC7},
  {0x0005020AUL, 0xF7},
  {0x0005020BUL, 0xFE},
  {0x0005020CUL, 0xFF},
  {0x5D05020DUL, 0x5B}, /* pop ebx - get angle */
  {0x5F05020EUL, 0x58}, /* pop eax - get struct */
  {0x5E05020FUL, 0x5A}, /* pop edx - get distance */
  {0x5A050210UL, 0x50}, /* push eax - save struct */
  {0x59050211UL, 0x53}, /* push ebx - save angle */
  {0x5B050212UL, 0xEB}, /* jump to [SL2] */
  {0xC3050213UL, 0x01},
  {0x53050214UL, 0xC3}, /* each null func must return immediately since its body changed */
  {0x51050215UL, 0x33}, /* [SL2] xor ebx, ebx - ebx must be zero (optional flag) */
  {0x52050216UL, 0xDB},
  {0x56050217UL, 0xE8}, /* call MoveForward(eax:struct, edx:distance, ebx:0) */
  {0x57050218UL, 0x98},
  {0x55050219UL, 0xF0},
  {0x8905021AUL, 0xFE},
  {0xE505021BUL, 0xFF},
  {0x8105021CUL, 0x33}, /* xor ebx, ebx - ebx must be zero (optional flag) */
  {0xEC05021DUL, 0xDB},
  {0x0005021EUL, 0x5A}, /* pop edx - get angle */
  {0x0005021FUL, 0x58}, /* pop eax - get struct */
  {0x00050220UL, 0xE9}, /* jmp TurnRight(eax:struct, edx:angle, ebx:0) - turn 90 degree to the right... */
  {0x00050221UL, 0x1F}, /* ...this will allow to return look angle back as it was before strafe... */
  {0x5D050222UL, 0xF8}, /* ...also note jmp here instead of call - shorter code */
  {0x5F050223UL, 0xFE},
  {0x5E050224UL, 0xFF},
  /* Strafe Right func instead of two null funcs */
  {0x5305151BUL, 0xC3}, /* each null func must return immediately since its body changed */
  {0x5105151CUL, 0x52}, /* [SR1] */
  {0x5205151DUL, 0x50},
  {0x5605151EUL, 0xBA},
  {0x5705151FUL, 0x40},
  {0x55051520UL, 0x0B},
  {0x89051521UL, 0x00},
  {0xE5051522UL, 0x00},
  {0x81051523UL, 0x52},
  {0xEC051524UL, 0xE8}, /* call TurnRight() */
  {0x00051525UL, 0x1B},
  {0x00051526UL, 0xE5},
  {0x00051527UL, 0xFE},
  {0x00051528UL, 0xFF},
  {0x5D051529UL, 0x5B},
  {0x5F05152AUL, 0x58},
  {0x5E05152BUL, 0x5A},
  {0x5A05152CUL, 0x50},
  {0x5905152DUL, 0x53},
  {0x5B05152EUL, 0xEB}, /* jump to [SR2] */
  {0xC305152FUL, 0x01},
  {0x53051530UL, 0xC3}, /* each null func must return immediately since its body changed */
  {0x51051531UL, 0x33}, /* [SR2] */
  {0x52051532UL, 0xDB},
  {0x56051533UL, 0xE8}, /* call MoveForward() */
  {0x57051534UL, 0x7C},
  {0x55051535UL, 0xDD},
  {0x89051536UL, 0xFE},
  {0xE5051537UL, 0xFF},
  {0x81051538UL, 0x33},
  {0xEC051539UL, 0xDB},
  {0x0005153AUL, 0x5A},
  {0x0005153BUL, 0x58},
  {0x0005153CUL, 0xE9}, /* jmp TurnLeft() */
  {0x0005153DUL, 0x93},
  {0x5D05153EUL, 0xE4},
  {0x5F05153FUL, 0xFE},
  {0x5E051540UL, 0xFF}
};

static fix_item fdhkmsvw[] = {
  /* fall through EVT_MOUSE_MOVING check (mouse usage always on) */
  {0x0A0426A2UL, 0x00},
  {0x030426A3UL, 0x00},
  /* fall through first check - set mouse cursor to the screen center */
  {0x340426BEUL, 0x00},
  /* fall through second check - always test for out of bounds */
  {0x750426EFUL, 0x00},
  /* skip MoveForward / MoveBackward code for mouse */
  {0x0F04289AUL, 0x90},
  {0x8D04289BUL, 0xE9},
  {0x8004289CUL, 0x17},
  {0x0004289DUL, 0x01}
};

static fix_item fdhkmsen[] = {
  /* TurnLeft() increase sensivity */
  {0x0603FA11UL, 0x06},
  /* TurnRight() increase sensivity */
  {0x0603FA81UL, 0x06}
};

static fix_item fdhkgive[] = {
  /* all weapons available mask */
  {0x0504A0B8UL, 0x7F},
  /* 200 bullets for pistol / machine gun */
  {0x1404A0CFUL, 0xC8},
  /* 50 grenades for grenade launcher */
  {0x0004A0DAUL, 0x32},
  /* 75 gas for flame thrower */
  {0x0004A0E5UL, 0x4B},
  /* 100 energy for last mystery weapon */
  {0x0004A0F0UL, 0x64}
};

static fix_item fdhkhlth[] = {
  /* infinite health */
  {0x01046388UL, 0x00}
};

static fix_item fdhksmap[] = {
  /* show map */
  {0x00046392UL, 0x01}
};

static fix_item fdhkvmod[] = {
  /* view mode */
  {0x01046374UL, 0x00},
  {0x0104637EUL, 0x00}
};

static fix_item fdhkammo[] = {
  /* infinite ammo */
  {0x00046356UL, 0x01}
};

static fix_item fdhkwall[] = {
  /* walk through walls - noclip */
  {0x0104632EUL, 0x00}
};

static fix_item fdhkcrds[] = {
  /* show coords */
  {0x00046324UL, 0x01}
};

static fix_info fdlshack[] = {
  {PH_ORG, 0, LIST_LEN(fdhkstrf), fdhkstrf},
  {PH_ORG, 0, LIST_LEN(fdhkmsvw), fdhkmsvw},
  {PH_ORG, 0, LIST_LEN(fdhkmsen), fdhkmsen},
  {PH_ORG, 0, LIST_LEN(fdhkgive), fdhkgive},
  {PH_ORG, 0, LIST_LEN(fdhkhlth), fdhkhlth},
  {PH_ORG, 0, LIST_LEN(fdhkammo), fdhkammo},
  {PH_ORG, 0, LIST_LEN(fdhksmap), fdhksmap},
  {PH_ORG, 0, LIST_LEN(fdhkcrds), fdhkcrds},
  {PH_ORG, 0, LIST_LEN(fdhkvmod), fdhkvmod},
  {PH_ORG, 0, LIST_LEN(fdhkwall), fdhkwall}
};

#endif
