#ifndef __HACKS3CD_H
#define __HACKS3CD_H

#include "PATCHACK.H"

/* compact disk */

/* Options hacks */

static fix_item cdmusvol[] = {
  {0x0A03492AUL, 0x0A},
  /* actual music volume byte */
  {0x7F07943CUL, 0x7F}
};

static fix_item cdsndvol[] = {
  {0x0A034934UL, 0x0A}
};

static fix_item cddfflev[] = {
  {0x020349A9UL, 0x02}
};

static fix_item cdhazlev[] = {
  {0x01041D71UL, 0x01}
};

static fix_item cdflrlev[] = {
  {0x01041B62UL, 0x01}
};

static fix_item cdwlldet[] = {
  {0x00041B58UL, 0x00}
};

static fix_item cdmsesns[] = {
  {0x010349C5UL, 0x01}
};

static fix_info cdlsopts[] = {
  {PH_ORG, 0, LIST_LEN(cdmusvol), cdmusvol},
  {PH_ORG, 0, LIST_LEN(cdsndvol), cdsndvol},
  {PH_ORG, 0, LIST_LEN(cddfflev), cddfflev},
  {PH_ORG, 0, LIST_LEN(cdhazlev), cdhazlev},
  {PH_ORG, 0, LIST_LEN(cdflrlev), cdflrlev},
  {PH_ORG, 0, LIST_LEN(cdwlldet), cdwlldet},
  {PH_ORG, 0, LIST_LEN(cdmsesns), cdmsesns}
};

/* Hacks setup */

static fix_item cdhkstrf[] = {
  /*
    explanation for the strafe code hack
    * pair of two consecutive null funcs at offsets 0005093F, 00050954 and 00051C5B, 00051C70 was
      used for strafe code placing in the game executable file, since it's new additional feature
      and nothing should be changed, replaced or removed
    * null func is a func that does nothing, but useless pushes and pops registers to / from stack
      so if func immediately returns (C3) all these wasted bytes can be used for something meaningful
      and if you wonder why this code exists in the first place - it's because compilers at that time
      didn't optimize and remove unused or obviously empty code (it's nice, since this come in handy)
    * let's see main idea behind this hack on Strafe Left implementation:
      - Turn Left to 90* degree
      - Move Forward
      - Turn Right to 90* degree to restore original view angle
      the same with the Strafe Right except calls for the Turn Left and Turn Right will be exchanged
    * note that 2880 (0B40h) equal to the 90* degree in the game units
  */
  /* Turn Left => Strafe Left */
  {0x120428BBUL, 0x0E}, /* replace rotate coeff with move coeff */
  {0x120428CFUL, 0x0E},
  {0xEA042906UL, 0x36}, /* replace TurnLeft call to [SL1] */
  {0xD2042907UL, 0xE0},
  {0xFF042908UL, 0x00},
  {0xFF042909UL, 0x00},
  /* Turn Right => Strafe Right */
  {0x1204292BUL, 0x0E}, /* replace rotate coeff with move coeff */
  {0x1204293FUL, 0x0E},
  {0xF104296FUL, 0xE9}, /* replace TurnRight call to [SR1] */
  {0xD2042970UL, 0xF2},
  {0xFF042971UL, 0x00},
  {0xFF042972UL, 0x00},
  /* Strafe Left func instead of two null funcs */
  {0x5305093FUL, 0xC3}, /* each null func must return immediately since its body changed */
  {0x51050940UL, 0x52}, /* [SL1] push edx - save argument (distance to move) */
  {0x52050941UL, 0x50}, /* push eax - save argument (global data offset to structure) */
  {0x56050942UL, 0xBA}, /* mov  edx, 0B40h - angle - 90 degree in the game units */
  {0x57050943UL, 0x40},
  {0x55050944UL, 0x0B},
  {0x89050945UL, 0x00},
  {0xE5050946UL, 0x00},
  {0x81050947UL, 0x52}, /* push edx - save angle */
  {0xEC050948UL, 0xE8}, /* call TurnLeft(eax:struct, edx:angle, ebx:0) - turn 90 degree to the left */
  {0x00050949UL, 0xA7},
  {0x0005094AUL, 0xF2},
  {0x0005094BUL, 0xFE},
  {0x0005094CUL, 0xFF},
  {0x5D05094DUL, 0x5B}, /* pop ebx - get angle */
  {0x5F05094EUL, 0x58}, /* pop eax - get struct */
  {0x5E05094FUL, 0x5A}, /* pop edx - get distance */
  {0x5A050950UL, 0x50}, /* push eax - save struct */
  {0x59050951UL, 0x53}, /* push ebx - save angle */
  {0x5B050952UL, 0xEB}, /* jump to [SL2] */
  {0xC3050953UL, 0x01},
  {0x53050954UL, 0xC3}, /* each null func must return immediately since its body changed */
  {0x51050955UL, 0x33}, /* [SL2] xor ebx, ebx - ebx must be zero (optional flag) */
  {0x52050956UL, 0xDB},
  {0x56050957UL, 0xE8}, /* call MoveForward(eax:struct, edx:distance, ebx:0) */
  {0x57050958UL, 0x78},
  {0x55050959UL, 0xEB},
  {0x8905095AUL, 0xFE},
  {0xE505095BUL, 0xFF},
  {0x8105095CUL, 0x33}, /* xor ebx, ebx - ebx must be zero (optional flag) */
  {0xEC05095DUL, 0xDB},
  {0x0005095EUL, 0x5A}, /* pop edx - get angle */
  {0x0005095FUL, 0x58}, /* pop eax - get struct */
  {0x00050960UL, 0xE9}, /* jmp TurnRight(eax:struct, edx:angle, ebx:0) - turn 90 degree to the right... */
  {0x00050961UL, 0xFF}, /* ...this will allow to return look angle back as it was before strafe... */
  {0x5D050962UL, 0xF2}, /* ...also note jmp here instead of call - shorter code */
  {0x5F050963UL, 0xFE},
  {0x5E050964UL, 0xFF},
  /* Strafe Right func instead of two null funcs */
  {0x53051C5BUL, 0xC3}, /* each null func must return immediately since its body changed */
  {0x51051C5CUL, 0x52}, /* [SR1] */
  {0x52051C5DUL, 0x50},
  {0x56051C5EUL, 0xBA},
  {0x57051C5FUL, 0x40},
  {0x55051C60UL, 0x0B},
  {0x89051C61UL, 0x00},
  {0xE5051C62UL, 0x00},
  {0x81051C63UL, 0x52},
  {0xEC051C64UL, 0xE8}, /* call TurnRight() */
  {0x00051C65UL, 0xFB},
  {0x00051C66UL, 0xDF},
  {0x00051C67UL, 0xFE},
  {0x00051C68UL, 0xFF},
  {0x5D051C69UL, 0x5B},
  {0x5F051C6AUL, 0x58},
  {0x5E051C6BUL, 0x5A},
  {0x5A051C6CUL, 0x50},
  {0x59051C6DUL, 0x53},
  {0x5B051C6EUL, 0xEB}, /* jump to [SR2] */
  {0xC3051C6FUL, 0x01},
  {0x53051C70UL, 0xC3}, /* each null func must return immediately since its body changed */
  {0x51051C71UL, 0x33}, /* [SR2] */
  {0x52051C72UL, 0xDB},
  {0x56051C73UL, 0xE8}, /* call MoveForward() */
  {0x57051C74UL, 0x5C},
  {0x55051C75UL, 0xD8},
  {0x89051C76UL, 0xFE},
  {0xE5051C77UL, 0xFF},
  {0x81051C78UL, 0x33},
  {0xEC051C79UL, 0xDB},
  {0x00051C7AUL, 0x5A},
  {0x00051C7BUL, 0x58},
  {0x00051C7CUL, 0xE9}, /* jmp TurnLeft() */
  {0x00051C7DUL, 0x73},
  {0x5D051C7EUL, 0xDF},
  {0x5F051C7FUL, 0xFE},
  {0x5E051C80UL, 0xFF}
};

static fix_item cdhkmsvw[] = {
  /* fall through EVT_MOUSE_MOVING check (mouse usage always on) */
  {0x0A04297FUL, 0x00},
  {0x03042980UL, 0x00},
  /* fall through first check - set mouse cursor to the screen center */
  {0x3404299BUL, 0x00},
  /* fall through second check - always test for out of bounds */
  {0x750429CCUL, 0x00},
  /* skip MoveForward / MoveBackward code for mouse */
  {0x0F042B77UL, 0x90},
  {0x8D042B78UL, 0xE9},
  {0x80042B79UL, 0x17},
  {0x00042B7AUL, 0x01}
};

static fix_item cdhkmsen[] = {
  /* TurnLeft() increase sensivity */
  {0x0603FC31UL, 0x06},
  /* TurnRight() increase sensivity */
  {0x0603FCA1UL, 0x06}
};

static fix_item cdhkgive[] = {
  /* all weapons available mask */
  {0x0504A538UL, 0x7F},
  /* 200 bullets for pistol / machine gun */
  {0x1404A54FUL, 0xC8},
  /* 50 grenades for grenade launcher */
  {0x0004A55AUL, 0x32},
  /* 75 gas for flame thrower */
  {0x0004A565UL, 0x4B},
  /* 100 energy for last mystery weapon */
  {0x0004A570UL, 0x64}
};

static fix_item cdhkhlth[] = {
  /* infinite health */
  {0x01046678UL, 0x00}
};

static fix_item cdhksmap[] = {
  /* show map */
  {0x00046682UL, 0x01}
};

static fix_item cdhkvmod[] = {
  /* view mode */
  {0x01046664UL, 0x00},
  {0x0104666EUL, 0x00}
};

static fix_item cdhkammo[] = {
  /* infinite ammo */
  {0x00046646UL, 0x01}
};

static fix_item cdhkwall[] = {
  /* walk through walls - noclip */
  {0x0104661EUL, 0x00}
};

static fix_item cdhkcrds[] = {
  /* show coords */
  {0x00046614UL, 0x01}
};

static fix_info cdlshack[] = {
  {PH_ORG, 0, LIST_LEN(cdhkstrf), cdhkstrf},
  {PH_ORG, 0, LIST_LEN(cdhkmsvw), cdhkmsvw},
  {PH_ORG, 0, LIST_LEN(cdhkmsen), cdhkmsen},
  {PH_ORG, 0, LIST_LEN(cdhkgive), cdhkgive},
  {PH_ORG, 0, LIST_LEN(cdhkhlth), cdhkhlth},
  {PH_ORG, 0, LIST_LEN(cdhkammo), cdhkammo},
  {PH_ORG, 0, LIST_LEN(cdhksmap), cdhksmap},
  {PH_ORG, 0, LIST_LEN(cdhkcrds), cdhkcrds},
  {PH_ORG, 0, LIST_LEN(cdhkvmod), cdhkvmod},
  {PH_ORG, 0, LIST_LEN(cdhkwall), cdhkwall}
};

#endif
