/*#define INT9_TEST 1*/

#ifdef INT9_TEST
#include <stdio.h>
#include <stdlib.h>
#endif

#include <dos.h>

#pragma pack(push, 1)
typedef struct {
  short code;
  char  name[8];
} key_item;
#pragma pack(pop)

#define MAX_KEYS 109
static key_item keys[MAX_KEYS + 1] = {
  {0x000, "N/A"},
  {0x001, "Escape"},
  {0x002, "1"},
  {0x003, "2"},
  {0x004, "3"},
  {0x005, "4"},
  {0x006, "5"},
  {0x007, "6"},
  {0x008, "7"},
  {0x009, "8"},
  {0x00A, "9"},
  {0x00B, "0"},
  {0x00C, "-"},
  {0x00D, "="},
  {0x00E, "BakSpc"},
  {0x00F, "Tab"},
  {0x010, "Q"},
  {0x011, "W"},
  {0x012, "E"},
  {0x013, "R"},
  {0x014, "T"},
  {0x015, "Y"},
  {0x016, "U"},
  {0x017, "I"},
  {0x018, "O"},
  {0x019, "P"},
  {0x01A, "["},
  {0x01B, "]"},
  {0x01C, "Enter"},
  {0x01D, "LCtrl"},
  {0x01E, "A"},
  {0x01F, "S"},
  {0x020, "D"},
  {0x021, "F"},
  {0x022, "G"},
  {0x023, "H"},
  {0x024, "J"},
  {0x025, "K"},
  {0x026, "L"},
  {0x027, ";"},
  {0x028, "'"},
  {0x029, "`"},
  {0x02A, "LShift"},
  {0x02B, "\\"},
  {0x02C, "Z"},
  {0x02D, "X"},
  {0x02E, "C"},
  {0x02F, "V"},
  {0x030, "B"},
  {0x031, "N"},
  {0x032, "M"},
  {0x033, ","},
  {0x034, "."},
  {0x035, "/"},
  {0x036, "RShift"},
  {0x037, "KPad*"},
  {0x038, "LAlt"},
  {0x039, "Space"},
  {0x03A, "CapLck"},
  {0x03B, "F1"},
  {0x03C, "F2"},
  {0x03D, "F3"},
  {0x03E, "F4"},
  {0x03F, "F5"},
  {0x040, "F6"},
  {0x041, "F7"},
  {0x042, "F8"},
  {0x043, "F9"},
  {0x044, "F10"},
  {0x045, "NumLck"},
  {0x046, "ScrLck"},
  {0x047, "KPad7"},
  {0x048, "KPad8"},
  {0x049, "KPad9"},
  {0x04A, "KPad-"},
  {0x04B, "KPad4"},
  {0x04C, "KPad5"},
  {0x04D, "KPad6"},
  {0x04E, "KPad+"},
  {0x04F, "KPad1"},
  {0x050, "KPad2"},
  {0x051, "KPad3"},
  {0x052, "KPad0"},
  {0x053, "KPad."},
  {0x054, "#84#"},   /* FIXME: E1? Alt+SysRq? also E1? 0x146 - Ctrl+Break? */
  {0x055, "#85#"},   /* FIXME: FN ? */
  {0x056, "#86#"},   /* FIXME: Empty key? */
  {0x057, "F11"},
  {0x058, "F12"},
  /* Extended keys */
  {0x059, "Pause"},  /* FIXME: pause doesn't have separate code */
  {0x148, "Up"},
  {0x150, "Down"},
  {0x14B, "Left"},
  {0x14D, "Right"},
  {0x152, "Insert"},
  {0x153, "Delete"},
  {0x060, "#96#"},   /* FIXME: ??? */
  {0x147, "Home"},
  {0x14F, "End"},
  {0x149, "PgUp"},
  {0x151, "PgDn"},
  {0x138, "RAlt"},
  {0x11D, "RCtrl"},
  {0x135, "KPad/"},
  {0x11C, "KpdEnt"},
  {0x137, "PrtScn"},
  /* Windows keyboard keys, works only in pure DOS */
  {0x15B, "LWin"},
  {0x15C, "RWin"},
  {0x15D, "Menu"},
  /* last item for all unknown keys */
  {0xFFF, "Unknwn"}
};

static unsigned char lPauseSeq[] = {0xE1, 0x1D, 0x45, 0xE1, 0x9D, 0xC5, 0x00};
static unsigned char nPauseNum;

static unsigned char  bExtKey;
static unsigned short nLastKey;
static unsigned short nFlag;

#ifdef __cplusplus
#define __CPPARGS ...
#else
#define __CPPARGS
#endif
typedef void interrupt (*VECTPROC)(__CPPARGS);

#define KEY_RELEASED 0x8000
void interrupt Int9Hook(__CPPARGS) {
unsigned char b, v;
  b = inp(0x60);
  v = inp(0x61);
  outp(0x61, v | 0x80);
  outp(0x61, v);
  outp(0x20, 0x20);
  if (b == lPauseSeq[nPauseNum]) {
    nPauseNum++;
    if (!lPauseSeq[nPauseNum]) {
      nPauseNum = 0;
      /* ignore Pause key */
    }
  } else {
    nPauseNum = 0;
    /* extended key */
    if (b >= 0xE0) {
      /* how much keys in the sequence */
      bExtKey = b - 0xE0 + 1;
      nFlag = bExtKey;
      nFlag <<= 8;
    } else {
      nFlag &= bExtKey ? 0xFF00 : 0x0000;
      /* skip this key */
      bExtKey -= bExtKey ? 1 : 0;
    }
    /* not extended key */
    if (!bExtKey) {
      if (b & 0x80) {
       /* key released */
        b ^= 0x80;
        if (nLastKey == (nFlag | b)) {
          nLastKey |= KEY_RELEASED;
        }
      } else {
        /* key pressed */
        nLastKey = nFlag | b;
      }
    }
  }
}

unsigned short GetScanCode(void) {
VECTPROC Int9Prev;
  nFlag = 0;
  bExtKey = 0;
  nLastKey = 0;
  nPauseNum = 0;
  Int9Prev = getvect(0x09);
  setvect(0x09, Int9Hook);
  while (!(nLastKey & KEY_RELEASED));
  setvect(0x09, Int9Prev);
  return(nLastKey ^ KEY_RELEASED);
}

char *GetNameByScanCode(int code) {
int i;
  code = (code <= 0) ? 0 : code;
  for (i = 0; i < MAX_KEYS; i++) {
    if (keys[i].code == code) {
      break;
    }
  }
  return(keys[i].name);
}

#ifdef INT9_TEST
int main(void) {
int k;
  printf("Press a key...\n");
  k = GetScanCode();
  printf("%04X %s\n", k, GetNameByScanCode(k));
  return(0);
}
#endif
