#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <io.h>

#include "modsetup.h"
/* v1.1 */
#include "setevent.h"
#include "hackopts.h"

menuitem mainmenu[] = {
  {
    /* menu title */
    "Main Menu",
    /* subheader (green) */
    "Current Filename ( RADIAKI.EXE )",
    /* total menu items (this not included) */
    7
  },
  {
    /* menu item name */
    "Hacks setup",
    /* menu item hint */
    "Configure various hacks.",
    /* menu item flag */
    0
  },
  {
    "Options hacks",
    "Modify default game settings located in options menu.",
    0
  },
  {
    "Configuration setup",
    "Change key and button assignments in \"DATA\\EVENTS.IFF\" file.",
    0
  },
  {
    "Advertisement",
    "Some related advertisement. Check it out!",
    0
  },
  {
    "About DeHacker",
    "Information about this program.",
    0
  },
  {
    "Save settings and exit",
    "Save the current settings and exit.",
    0
  },
  {
    "Exit without saving settings",
    "Exit without saving any changes.",
    0
  }
};

menuitem maininfo[] = {
  {"About DeHacker", NULL, 9 | MENU_NFOBOX},
  {"The Fortress of Dr. Radiaki DeHacker Version 1.1", NULL, 0},
  {"(c) -=CHE@TER=- 2018,2020", NULL, 0},
  {"e-mail: _CTPAX_@MAIL.RU", NULL, 0},
  {"http://ctpax-cheater.losthost.org/htmldocs/trouble.htm", NULL, 0},
  {"Thanks to Corak for testing.", NULL, 0},
  {"", NULL, 0},
  {"Compatibility fixes for DOS and old Windows games and software.", NULL, 0},
  {"Hiring? Offering a one-time job? Paid requests are always welcome!", NULL, 0},
  {"Contact for more details.", NULL, 0}
};

menuitem mainexit[] = {
  {"Save settings?", NULL, 2 | MENU_DLGBOX},
  {"Yes", "Save current settings and exit program.", 0},
  {"No", "Do not save current settings, but exit program.", 0}
};

static menuitem mainmisc[] = {
  {"Advertisement", NULL, 17 | MENU_NFOBOX},
  {"Introducing Reviver, a patch for the game Scorcher (1996, Zyrinx/Scavenger).", NULL, 0},
  {"Some of the Scorcher Reviver features:", NULL, 0},
  {"* support for retro gaming PCs and modern systems - you can run Reviver", NULL, 0},
  {"  on anything from Windows 98 to Windows 10 or even under *nix with Wine", NULL, 0},
  {"* screen resolution not limited to 640x480 anymore, fullscreen and", NULL, 0},
  {"  new windowed borderless fullscreen mode", NULL, 0},
  {"* fully configurable gamepad / joystick / game controller, usable in menu", NULL, 0},
  {"* new challenging game modes: Survival, Insanity and Speedrun", NULL, 0},
  {"* streaming music from wave-files - CD disc not required to play", NULL, 0},
  {"* fixes to improve gameplay experience such as auto use 1st person view", NULL, 0},
  {"* a lot of original bugs patched like non saved highscores and settings", NULL, 0},
  {"* partial modding support with external files and much, much more!", NULL, 0},
  {"Try it now with the demo version of the game:", NULL, 0},
  {"https://games.softpedia.com/get/Patch/Scorcher-Reviver.shtml", NULL, ITEM_GRAYED},
  {"Or win a free registration key for Reviver (see topic page 37 for details):", NULL, 0},
  {"https://forum.speeddemosarchive.com/post/cash_bounties_for_speedruns361.html", NULL, ITEM_GRAYED},
  {"(c) SysTools 2018-2020 Reviver is only a patch, game itself required to run.", NULL, 0}
};

int MenuProc(int item, BYTE *key) {
  if (!key) {
    switch (item) {
      /* hacks */
      case 1:
        DoHacksMenu();
        SetMenuData(mainmenu[item], 1);
        break;
      /* options */
      case 2:
        DoOptionsMenu();
        SetMenuData(mainmenu[item], 1);
        break;
      /* controls */
      case 3:
        DoEventsMenu();
        break;
      /* misc */
      case 4:
        DrawMenu(mainmisc, NULL);
        break;
      /* about */
      case 5:
        DrawMenu(maininfo, NULL);
        break;
      /* exit */
      case 6:
      case 7:
        item = 0;
        break;
    }
  }
  return(item);
}

int main(void) {
int i, k;
  /* startup */
  InitSetup(maininfo[1].item, maininfo[2].item);
  /* if no game executables found */
  if (!LoadHackOptions()) {
    /* disable hacks menu items */
    mainmenu[0].hint = NULL; /* hide subheader */
    mainmenu[1].flag |= ITEM_GRAYED; /* disable hacks menu */
    mainmenu[2].flag |= ITEM_GRAYED; /* disable options menu */
    mainmenu[6].flag |= ITEM_GRAYED; /* disable save changes menu */
  }
  if (!LoadEventsData()) {
    /* disable hacks menu items */
    mainmenu[3].flag |= ITEM_GRAYED; /* disable events setup menu */
  }
  /* show main menu */
  i = DrawMenu(mainmenu, MenuProc);
  /* hacks menu opened flag */
  k = (GetMenuData(mainmenu[2]) << 1) | GetMenuData(mainmenu[1]);
  /* if save changes or yes in additional menu */
  if ((k) && ((i == 6) || ((i == 0) && (DrawMenu(mainexit, NULL) == 1)))) {
    /* save patches */
    SaveHackOptions(k);
  }
  /* cleanup */
  FreeSetup();
  return(0);
}
