#include <io.h>
#include <fcntl.h>
#include <stdarg.h>
#include <string.h>

#include "xscommon.h"

/*
  FILE and fopen(), fclose(), etc.
  adds a lot of code
  so avoid to use it
  use open() instead
*/

int FileExists(char *fname, unsigned long fsize) {
int fl;
  fl = open(fname, O_RDONLY | O_BINARY);
  if (fl != -1) {
    if (fsize) {
      lseek(fl, 0, SEEK_END);
      fsize ^= (unsigned long) tell(fl);
    }
    close(fl);
  } else {
    fsize = 1;
  }
  return(fsize ? 0 : 1);
}

/*
  sprintf() adds a lot of code
  (not only the function itself but the error strings for floating types, etc.)
  so avoid to use that function
  arguments:
  buf - output buffer
  len - length in characters of output buffer (including last zero tail char)
  ... - strings to merge, last one MUST be NULL (used as arguments terminator)
*/
void StrMerge(char *buf, unsigned int len, ...) {
va_list args;
char *s;
  /* sanity checks */
  if (buf && len) {
    va_start(args, len);
    /* reserved 1 char for tail null */
    len--;
    /* merge all strings */
    do {
      s = va_arg(args, char *);
      if (s) {
        while (*s && len) {
          *buf = *s;
          buf++;
          s++;
          len--;
        }
      }
    } while (s && len);
    va_end(args);
    /* tail null */
    *buf = 0;
  }
}

/* put source string s inside destination string d
   from position f right aligned padding with spaces at left */
void StrOverlap(char *d, char *s) {
size_t i, j;
  /* sanity checks */
  if (d && s) {
    i = strlen(d);
    j = strlen(s);
    if (j < i) {
      i -= j;
      memset(d, ' ', i);
    } else {
      j = i;
      i = 0;
    }
    memcpy(&d[i], s, j);
  }
}
